/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.evasion.ejb.local;

/**
 *
 * @author sebastien.glon
 */
public interface ParametreManagerLocal {

    /**
     * Sauvegarde un Parametre si son nom n'est pas deja present en base.
     *
     * @param property Nom du parametre.
     * @param valeur Valeur du parametre.
     * @return true si parametre enregistre;<br>
     * false si erreur d'enregistrment ou prorpiete deja existente en base;
     */
    Boolean saveParametre(String property, String valeur);

    /**
     * Force la sauvegarde d'un parametre en base.
     *
     * @param property Nom du parametre.
     * @param valeur Valeur du parametre.
     * @param force True pour forcer la sauvegarde si le parametre existe deja en base.
     * @return true si parametre enregistre;<br>
     * false si erreur d'enregistrment, prorpiete deja existente en base et force =false;
     */
    Boolean saveParametre(String property, String valeur, Boolean force);

    void deleteParametre(String property);

    String getProperty(String property);
}
