/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.evasion.ejb.local;

import java.util.Locale;
import java.util.Map;

/**
 *
 * @author sebastien
 */
public interface TemplateManagerLocal {

    /**
     * Création ou modification d'un template.
     * @param key clé d'identification du template.
     * @param locale locale du template.
     * @param text texte du template.
     */
    void saveTemplate(String key, Locale locale, String text);

    /**
     * Création ou modification d'un template de mailù.
     * @param key clé d'identification du template.
     * @param locale locale du template.
     * @param subject sujet du mail.
     * @param body corps du mail.
     */
    void saveEmailTemplate(String key, Locale locale, String subject, String body);
    /**
     * Récupération d'un template brut.
     * @param key clé d'identification du template.
     * @param locale locale du template.
     * @return text texte du template.
     */
    String getTemplate(String key, Locale locale);

    /**
     * Merge un template avec un ensemble de propriete.
     * @param key clé d'identification du template.
     * @param locale locale du template.
     * @param properties propriete à introduire lors du merge.
     * @return le texte comptlété.
     */
    String merge(String key, Locale locale, Map<String, ? extends Object> properties);
}
