package com.evasion.ejb.remote;

import com.evasion.entity.geolocation.Location;
import com.evasion.exception.EvasionException;
import java.util.List;

/**
 *
 * @author sebastien.glon
 */
public interface GeolocEJBRemote {

    /**
     * Importation des données de geolocalisation dans le référentiel.
     *
     * @param file Fichier à traiter.
     * @param format Format du fichier (A ce jour seul le format geoname-CSV est
     * prit en charge.
     * @return
     * <code>true</code> si importation réussi;
     * <code>false</false> sinon
     */
    boolean importData(String file, String format) throws EvasionException;

    /**
     * Cette méthode est à utiliser pour rafraichir la config du timer d'import
     * des référenciels de geoloc.
     */
    void updateImportTimer() throws EvasionException;

    Location getLocationByid(long number);

    List<Location> searchFullTextLocation(String query) throws EvasionException;
}
