/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.evasion.entity.postal;

import com.evasion.EntityJPA;
import com.evasion.entity.geolocation.Country;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;

/**
 * Definit le comtenu d'une adresse au format international.
 * definition tire du site : <link>http://en.wikipedia.org/wiki/Address_(geography)</link>
 * <br>
 * Le nom de la personne et/ou de l'entreprise seront rattache avec une methode abstraite.
 * @author user
 */
@Entity
public class Adresse extends EntityJPA<Long> {
    /***
     * serialVersionUID.
     */
    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue
    private Long id;

    @Column(nullable = false, length = 512)
    private String rue;

    @Column(nullable = true, length = 255)
    private String quartier;

    @Column(nullable = false, length = 255)
    private String ville;

    private String etat;

    private Country country;

    private String postCode;

    @Override
    public Long getId() {
        return this.id;
    }

    @Override
    public void setId(Long id) {
        this.id=id;
    }
}
